(function(){
    var dmlife = window.dmlife || window.androidWebBridge;
    window.OTOJSInterface = dmlife;
    if (typeof(dmlife) == "undefined" || (typeof(window.dmlife) != "undefined" && dmlife.openModule)) {
         return;
    } else {
       var d = document;

       var documentReady = function(){

       };

       var guid = function() {
         return 'xxxxxxxxxxxxxxxxyxxxxxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
           var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
           return v.toString(16);
         });
       };

       var attachClickEventToLinks = function() {
           var links = document.getElementsByTagName("a");
           for (var i = 0; i < links.length; i++) {
               var link = links[i];
               link.addEventListener("click", function(event) {
                   var url = this.href;
                   if (url) {
                       openURLInNative(url);
                   }
               });
           }
       };

       var sendMessageToNative = (function(){
           if (window && window.webkit && window.webkit.messageHandlers && window.webkit.messageHandlers.dmlife) {
               return function(message) {
                   window.webkit.messageHandlers.dmlife.postMessage(message);
               };
           }

           return function(message) {
           if (message.event == "showExplaination") {
              var content='';
              for(var i=0;i<message.explainations.length;i++) {
                  if(message.explainations[i].title) {var title = message.explainations[i].title.replace("\n", "<br>"); content = content + title + '<br>';}
                  if(message.explainations[i].text) {var text = message.explainations[i].text.replace("\n", "<br>"); var content = content + '<font color="#7f7f7f">' + text + '</font>'+ '<br><br>';}
              };
              dmlife.showExplaination(message.title, content);
           } else if (message.event == "common_showExplainations") {
              var content='';
              for(var i=0;i<message.params.explainations.length;i++) {
                  if(message.params.explainations[i].title) {var title = message.params.explainations[i].title.replace("\n", "<br>"); content = content + title + '<br>';}
                  if(message.params.explainations[i].text) {var text = message.params.explainations[i].text.replace("\n", "<br>"); var content = content + '<font color="#7f7f7f">' + text + '</font>'+ '<br><br>';}
              };
              dmlife.showExplaination(message.params.title, content);
           } else if (message.event == "didTouchPurchaseButton") {
             dmlife.didTouchPurchaseButton(message.fundttType);
           } else if (message.event == "se_reloadCurrentModule") {
             dmlife.reload(JSON.stringify(message.params));
           } else if (message.event == "se_updateLoadingActivity") {
             dmlife.handleLoadingDialog(JSON.stringify(message.params));
           } else if (message.event == "se_setPanGestureEnabled") {
             dmlife.setSupportSwipeback(message.params.enabled);
           } else if (message.event == "se_updateNavBar") {
             dmlife.setNavigation(JSON.stringify(message.params));
           } else if (message.event == "se_callbackToInvokeeModule") {
             dmlife.webCallback(JSON.stringify(message.params));
           } else if(message.event == "consult_viewOrCustomPortfolio") {
             dmlife.personalConsult();
           } else if(message.event == "se_setModuleParamForKey") {
             dmlife.updatesModuleParams(JSON.stringify(message.params));
           } else if(message.event == "showCurrentProductInstruct") {
             message = JSON.stringify(message.contents);
             dmlife.showProductInstruction(message);
           }  else if(message.event == "setCustomBackButtonNativeHandler") {
             dmlife.setBackButtonHandler(JSON.stringify(message.params));
           } else if(message.event == "returnUrl") {
             dmlife.nativeReturnUrl(JSON.stringify(message.params));
           }else if(message.event == "androidSendSMS") {
             dmlife.nativeAndroidSendSMS(JSON.stringify(message.params));
           } else if(message.event == "setBackBtnRunJS") {
             dmlife.nativesetBackBtnRunJS(JSON.stringify(message.params));
           } else if(message.event == "saveImageToPhotoAlbum") {
             dmlife.nativeSaveImageToPhotoAlbum(JSON.stringify(message.params));
           } else if(message.event == "se_dismissCurrentModule") {
              if (message.params == null || message.params == undefined || message.params == '') {
                 dmlife.closePage('');
              } else {
                 dmlife.closePage(JSON.stringify(message.params));
              }
           } else if(message.event == "openExternalApp") {
              dmlife.nativeOpenExternalApp(JSON.stringify(message.params));
           } else {
             message = JSON.stringify(message);
             dmlife.onWebMessage(message);
           }
         }
       })();

       var openURLInNative = function(url) {
           sendMessageToNative({"navigationURL": url});
       };

       var triggerEventToNative = function(eventName, params, isSystemEvent) {
           if (!eventName) {
               return;
           }

           var systemEventPrefix = 'se_';
           if (eventName.indexOf(systemEventPrefix) != 0 && isSystemEvent) {
               eventName = systemEventPrefix + eventName;
           }
           sendMessageToNative({event: eventName, params: params});
       };

       var onEvent = function(eventName, params) {
           if (!eventName) {
              return;
           }

           sendMessageToNative({event: eventName, params: params});
       };

       var triggerSystemEventToNative = function(eventName, params) {
           triggerEventToNative(eventName, params, true);
       };
       /**
        * keys in params:
        * 1. navBarHidden: bool
        * 2. navBarAlha: float
        * 3. title: string
        * 4. rightBarItem: {label:"itemLabel", callback: callbackFunction}
        */
       var rightBarItemCallbackList = null;
       var updateNavBar = function(params){
           var rightBarItem = params["rightBarItem"];
           var rightBarItemList = params['rightBarItemList'];
           if (rightBarItem || rightBarItemList) {
               if (!rightBarItemList) {
                   rightBarItemList = [];
                   params['rightBarItemList'] = rightBarItemList;
               }

               if (rightBarItem) {
                   rightBarItemList.push(rightBarItem);
                   params["rightBarItem"] = null;
               }

               var callbacks = rightBarItemList.map(function(item){
                   var callback = item['callback'] || function(){};
                   item['callback'] = null;
                   return callback;
               });
               rightBarItemCallbackList = callbacks;
           }
           var backHandler = params["backHandler"];
           if (backHandler) {
              window.cjjBackHandler = backHandler;
              params["backHandler"] = "cjjBackHandler";
           }
           triggerSystemEventToNative('updateNavBar', params);
       };

       var onRightBarItemTouched = function(index){
           var callback = rightBarItemCallbackList && rightBarItemCallbackList[index];
           if (typeof callback === 'function') {
               callback();
           }
        };

       var updateLoadingActivity = function(show, loadingTitle){
           triggerSystemEventToNative('updateLoadingActivity', {show: show, loadingTitle: loadingTitle});
       };

       var showLoadingActivity = function(loadingTitle) {
           updateLoadingActivity(true, loadingTitle);
       };
       var hideLoadingActivity = function(){
           updateLoadingActivity(false);
       };

       var setPanGestureEnabled = function(enabled){
           triggerSystemEventToNative('setPanGestureEnabled', {enabled: enabled});
       };

       /**
        * url: url of module
        *
        * keys in options:
        * 1. isWebModule: bool
        * 2. dismissSelf: bool
        *
        * callback: function(response){}
        */
       var moduleCallbackCache = {};
       var lastCallbackIndex = 0;
       var pageId = guid();
       var openModule = function(url, params, callback, options){
           var callbackKey = null;
           var key = "";
           if (callback) {
               callbackKey = (lastCallbackIndex++).toString();
               moduleCallbackCache[callbackKey] = callback;
               key = pageId + "_" + callbackKey;
           }
           triggerSystemEventToNative('openModule', {url: url, params: params, options: options, callbackKey: key});
       };
       var onModuleCallbackFromNative = function(callbackKey, params){
           if (!callbackKey) {
               return;
           }

           if (callbackKey.indexOf(pageId) < 0) {
              return;
           }

           var indexStrs = callbackKey.split("_");
           if (indexStrs.length > 1) {
              var callback = moduleCallbackCache[indexStrs[1]];
              moduleCallbackCache[callbackKey] = undefined;
              if (!callback) {
                  return;
              }

              callback(params);
           }
       };

       var openWebModule = function(url, params, callback, options){
           options = options || {};
           options.isWebModule = true;
           openModule(url, params, callback, options);
       };

       var showToast = function(message){
           triggerSystemEventToNative('showToast', {message: message});
       };

       var setModuleParams = function(params){
           triggerSystemEventToNative('setModuleParamForKey', params);
       };

       var callbackToInvokeeModule = function(response, options){
           triggerSystemEventToNative('callbackToInvokeeModule', {'response':response, 'options':options});
       };

       var reloadCurrentModule = function(params){
           triggerSystemEventToNative('reloadCurrentModule', params);
       };

       var dismissCurrentModule = function(params){
           triggerSystemEventToNative('dismissCurrentModule', params);
       };

       var onDestroy = function() {
           if (typeof(onHide) == "function") {
              onHide();
           }
       };

       var onInjectSuccess = function() {
           if (typeof(androidInjectSuccess) == "function") {
               androidInjectSuccess();
           }
       };

       var setCustomBackButtonNativeHandler = function(eventHandlerName, params) {
          triggerEventToNative('setCustomBackButtonNativeHandler', {eventHandlerName:eventHandlerName, params:params});
       };

      var returnUrl = function(url){
           triggerEventToNative('returnUrl', {'url':url});
      };
      var androidSendSMS = function(phoneNumber, message){
           triggerEventToNative('androidSendSMS', {'phoneNumber':phoneNumber, 'message':message});
      };
      var appLogin = function(callback){
          openModule("appLogin", {}, callback, {});
      };

      var appGetLocation = function(callback){
          openModule("appGetLocation", {}, callback, {});
      };
      var setBackBtnRunJS = function(backEventFunc){
          triggerEventToNative('setBackBtnRunJS', {'backEventFunc':backEventFunc});
      };
      var navHeight = function(callback){
          openModule("navHeight", {}, callback, {});
      };

       var saveImageToPhotoAlbum = function(imageUrl){
            triggerEventToNative('saveImageToPhotoAlbum', {'imageUrl':imageUrl});
       };

       var openDepositoryDialog = function(params, callback){
           if (params && params.accountStatus == '3') {
               openModule("activateDepositoryDialog", {}, callback, {});
           } else {
               openModule("openDepositoryDialog", {}, callback, {});
           }
       };

       var openExternalApp = function(appName){
           triggerEventToNative('openExternalApp', {'appName':appName});
       };

       if (d.readyState == 'complete') {
           documentReady();
       } else {
           d.addEventListener('DOMContentLoaded', documentReady, false);
       }

       if (dmlife) {
           dmlife.updateNavBar = updateNavBar;
           dmlife.updateNavigationBar = updateNavBar;
           dmlife.showLoadingActivity = showLoadingActivity;
           dmlife.hideLoadingActivity = hideLoadingActivity;
           dmlife.setPanGestureEnabled = setPanGestureEnabled;
           dmlife.openModule = openModule;
           dmlife.openWebModule = openWebModule;
           dmlife.openURLInNative = openURLInNative;
           dmlife.sendMessageToNative = sendMessageToNative;
           dmlife.showToast = showToast;
           dmlife.triggerEventToNative = triggerEventToNative;
           dmlife.setModuleParams = setModuleParams;
           dmlife.callbackToInvokeeModule = callbackToInvokeeModule;
           dmlife.reloadCurrentModule = reloadCurrentModule;
           dmlife.pageDidBecomeVisible = function(info){};

           dmlife.onRightBarItemTouched = onRightBarItemTouched;
           dmlife.onModuleCallbackFromNative = onModuleCallbackFromNative;
           dmlife.dismissCurrentModule = dismissCurrentModule;
           dmlife.onDestroy = onDestroy;
           dmlife.setCustomBackButtonNativeHandler = setCustomBackButtonNativeHandler;
            dmlife.saveImageToPhotoAlbum = saveImageToPhotoAlbum;
           dmlife.onEvent = onEvent;

           window.dmlife = dmlife;
           window.$native = dmlife;

           dmlife.returnUrl = returnUrl;
           dmlife.androidSendSMS = androidSendSMS;
           dmlife.appLogin = appLogin;
           dmlife.appGetLocation = appGetLocation;
           dmlife.setBackBtnRunJS = setBackBtnRunJS;
           dmlife.navHeight = navHeight;
           dmlife.showOpenDepositoryDialog = openDepositoryDialog;
           dmlife.openExternalApp = openExternalApp;

           onInjectSuccess();
       }
    }
})();