(function (selectors) {
    selectors = selectors || {};
    selectors.name = selectors.name || "h3.name";
    selectors.price = selectors.price || "span.currentPrice > span:last";
    selectors.image = selectors.image || ".swiper-wrapper > div[data-swiper-slide-index=0]:first>img";

    var getGoodsIdFromQuery = function(){
        var query = window.location.search;
        query = query.startsWith("?") ? query.substring(1) : query;
        var urlParams = query.split("&");
        for (var index in (urlParams || [])) {
            var paramPairStr = urlParams[index];
            if (paramPairStr) {
                var paramPair = paramPairStr.split('=');
                if (paramPair.length == 2) {
                    var key = paramPair[0];
                    if (key && key.trim() == 'id'){
                        return paramPair[1];
                    }
                }
            }
        };

        return null;
    };

    var id = (jsonData && jsonData.id) || getGoodsIdFromQuery();
    var goodsUrl = window.location.href;
    var name = jsonData.name || $(selectors.name).text();
    var price = jsonData.retailPrice || $(selectors.price).text();
    var imageSrc = jsonData.primaryPicUrl || $(selectors.image).attr("src");

    var shareParams = {
        'itemId': id,
        'itemTitle': name,
        'params': {
            'goodsUrl': window.location.href,
            'imageUrl': imageSrc,
            'price': (price + '')
        }
    };

    console.log(JSON.stringify(shareParams));
    androidWebBridge.onShareParams(JSON.stringify(shareParams));

    return shareParams;
})(/*#selectorsForGetShareContent#*/);